import java.awt.Color;
import java.util.Arrays;

public class Eye implements Comparable<Eye> {
    private String strColor;
    private Color color;
    private String[] colorsList = {"black", "blue", "brown", "green"};

    Eye() {
        sortColorList();
    }

    /**
     * @param color
     */
    Eye(String color) {
        setStrColor(color);
        setColor(color);
        sortColorList();
    }

    public String getStrColor() {
        return strColor;
    }

    public void setStrColor(String strColor) {
        if (validateColor(strColor)) {
            this.strColor = strColor;
        } else {
            throw new IllegalArgumentException("Color must be" + new Eye().colorListToString());
        }
    }

    public String[] getColorsList() {
        return colorsList;
    }

    /**
     * @return
     */
    public Color getColor() {
        return color;
    }

    /**
     * @param color
     */
    public void setColor(String color) {
        if (validateColor(color)) {
            if (color.equals("brown"))
                this.color = new Color(88, 41, 0);
            else
                this.color = Color.getColor(color);

        } else {
            throw new IllegalArgumentException("Color must be" + new Eye().colorListToString());
        }
    }

    /**
     * @param color
     * @return
     */
    private boolean validateColor(String color) {
        for (String c : colorsList) {
            if (color.equals(c)) {
                return true;
            }
        }
        return false;
    }

    private void sortColorList() {
        Arrays.sort(this.colorsList);
    }

    /**
     * @param eye
     * @return
     */
    @Override
    public int compareTo(Eye eye) {
        double r_diff = this.getColor().getRed() - eye.getColor().getRed();
        double g_diff = this.getColor().getGreen() - eye.getColor().getGreen();
        double b_diff = this.getColor().getBlue() - eye.getColor().getBlue();
        //See https://en.wikipedia.org/wiki/Color_difference
        Double distance = Math.sqrt(2 * Math.pow(r_diff, 2) + 4 * Math.pow(g_diff, 2) + 3 * Math.pow(b_diff, 2));
        return distance.intValue();
    }

    private String colorListToString() {
        StringBuilder stringBuilder = new StringBuilder();
        for (String c : colorsList) {
            stringBuilder.append(" ");
            stringBuilder.append(c);
        }
        return stringBuilder.toString();
    }
}
